<template>
  <div class="TabBar">
    <el-tabs
      :stretch="true"
      v-shortkey="shortkeys"
      @shortkey.native="shortcutHandler"
      v-model="activeTab"
      ref="tabs"
      class="tabs">
      <slot/>
    </el-tabs>
  </div>
</template>

<script>
export default {
  props: {
    isClosableWindow: {
      default: true,
      type: Boolean,
    },
    value: {
      default: '',
      type: String,
    }
  },
  data() {
    return {
      right: 0,
      left: 0,
      shortkeys: {
        right: ['alt', 'ctrl', 'arrowright'],
        left: ['alt', 'ctrl', 'arrowleft'],
        exit: ['ctrl', 'w']
      }
    }
  },
  computed: {
    activeTab: {
      get() {
        return this.value
      },
      set() {
        this.$emit('input', this.value)
      }
    },
  },
  methods: {
    shortcutHandler(e) {
      if (e.srcKey === 'right') {
        const panes = this.$refs.tabs.panes
        const currentIndex = _.findIndex(panes, { active: true })
        const nextIndex = currentIndex === panes.length - 1 ? 0 : currentIndex + 1
        this.$emit('input', panes[nextIndex].name)
      }
      if (e.srcKey === 'left') {
        const panes = this.$refs.tabs.panes
        const currentIndex = _.findIndex(panes, { active: true })
        const nextIndex = currentIndex === 0 ? panes.length - 1 : currentIndex - 1
        this.$emit('input', panes[nextIndex].name)
      }
      if (e.srcKey === 'exit') {
        if (this.isClosableWindow) {
          nw.Window.get().close()
        } else {
          nw.Window.get().hide()
        }
      }
    }
  },
  mounted() {
    if (this.isClosableWindow) {
      nw.Window.get().focus()
    }
    ee.on('nextTab', () => {
      const panes = this.$refs.tabs.panes
      const currentIndex = _.findIndex(panes, { active: true })
      const nextIndex = currentIndex === panes.length - 1 ? 0 : currentIndex + 1
      this.$emit('input', panes[nextIndex].name)
    })
    ee.on('prevTab', () => {
      const panes = this.$refs.tabs.panes
      const currentIndex = _.findIndex(panes, { active: true })
      const nextIndex = currentIndex === 0 ? panes.length - 1 : currentIndex - 1
      this.$emit('input', panes[nextIndex].name)
    })
  },
}
</script>

<style lang="less" scoped>
@import "./TabBar.less";
</style>

<style lang="less">
.TabBar {
  transition: all 0.3s;
  .el-tabs__header {
    min-height: 39px;
  }
  .el-tabs__content {
    height: 100% !important;
  }
  .el-tab-pane {
    height: 100% !important;
  }
  .el-loading-mask {
    background-color: rgba(34, 41, 51, 0.9);
  }
  .el-tabs__item {
    -webkit-user-select: none;
    -moz-user-select: none;
    -ms-user-select: none;
    user-select: none;
  }
}
</style>
